// CartridgeMP3 V1 - code
// Library and base code from Adafruit, everything else from Justinas Petkauskas
// Please modify this and share it on instructables. My code sucks
// Enjoy your CartridgeMP3!


#include <SPI.h>
#include <SD.h>
#include <Adafruit_VS1053.h>

#define VS1053_RESET   -1     // VS1053 reset pin (not used!)
#define VS1053_CS       6     // VS1053 chip select pin (output)
#define VS1053_DCS     10     // VS1053 Data/command select pin (output)
#define CARDCS          5     // Card chip select pin
#define VS1053_DREQ     9     // VS1053 Data request, ideally an Interrupt pin

Adafruit_VS1053_FilePlayer musicPlayer = 
  Adafruit_VS1053_FilePlayer(VS1053_RESET, VS1053_CS, VS1053_DCS, VS1053_DREQ, CARDCS);

void setup() {

  pinMode(0, INPUT); // setting up all the cartridge interface inputs
  pinMode(1, INPUT);
  pinMode(2, INPUT);
  pinMode(3, INPUT);
  pinMode(A0, INPUT);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  pinMode(A3, INPUT);
  pinMode(A4, INPUT);
  pinMode(A5, INPUT);
  pinMode(11, INPUT);
  pinMode(12, INPUT);
  pinMode(13, OUTPUT);

  if (! musicPlayer.begin()) { // initializing the music player
     while (1);
  }
   
  if (!SD.begin(CARDCS)) { // initializing the SD card
    while (1);  
  }
  
  musicPlayer.setVolume(0,0); // sets volume...LOWER IS HIGHER
  
  musicPlayer.useInterrupt(VS1053_FILEPLAYER_TIMER0_INT); // Has something to do with file playback...not sure exactly what
}

void loop() { // First Track. Choose the cartridge pins that are pulled to ground and define them here, and then assign this to the track that is a few lines down. Tracknames can only be 8 letters long with a 3 letter extension!!!!!
   while (digitalRead(0) == LOW && digitalRead(1) == LOW && digitalRead(2) == HIGH)
   {
   analogWrite(13, 1); // Notification LED, PWM at minimum brightness 
   delay(871);  // random delay for dramatic effect
   musicPlayer.startPlayingFile("/track001.mp3"); // plays music!
   }
   
   while (digitalRead(A2) == HIGH && digitalRead(A3) == LOW && digitalRead(12) == LOW) // read the first one
   {
   analogWrite(13, 1);
   delay(692);
   musicPlayer.startPlayingFile("/track002.mp3");
   }
   
   while (digitalRead(0) == LOW && digitalRead(1) == LOW && digitalRead(2) == LOW)
   {
   analogWrite(13, 1);
   delay(748);  
   musicPlayer.startPlayingFile("/track003.mp3");
   }

   while (digitalRead(A2) == LOW && digitalRead(A3) == LOW && digitalRead(12) == LOW)
   {
   analogWrite(13, 1);
   delay(419);
   musicPlayer.startPlayingFile("/track004.mp3");
   }
}
  
